Subject: Re: [PATCH RESEND v3] make: add INSTALL_STRIP option variable

From: Đoàn Trần Công Danh <[email-masked]>
Date: Mon, 6 Sep 2021 10:11:47 +0700

On 2021-09-05 12:17:56-0700, Junio C Hamano <[email-masked]> wrote:
> Bagas Sanjaya <[email-masked]> writes:
> 
> >  [QUESTION]: I squashed Junio's suggestion patch to produce this patch,
> >  and I want to credit his work. In such situation, what should I do the
> >  right way? For now I add From: line and S-o-b trailer with his
> >  identity, in addition to my S-o-b.
> 
> As far as I'm concerned, everything we see in this resulting patch
> (like studying how we should sift $(ALL_PROGRAMS) into two classes,
> one that can be stripped and the other that shouldn't be) came from
> your brain.  I may have helped you in writing it down in a better
> form but I see it within the usual "Helped-by:".

FWIW, it was rewrite from my original suggestion in <YSjdc/[email-masked]>

> Applying this to the same base as the previous iteration of the
> topic that I queued in 'seen', and running "git range-diff" between
> them, I see that there is no difference at all, so I'll keep the one
> I already have, but I probably should correct the authorship
> information for it (I failed to notice you had in-body From: header
> that shifts the blame for this change on me---you should be the
> author of this change).
> 
> IOW, here is what I would expect in a situation like this.
> 
> -- >8 --
> From: Bagas Sanjaya <[email-masked]>
> Subject: [PATCH] make: add INSTALL_STRIP option variable
> 
> Add $(INSTALL_STRIP), which allows passing stripping options to
> $(INSTALL).
> 
> For this to work, installing executables must be split to installing
> compiled binaries and scripts portions, since $(INSTALL_STRIP) is only
> meaningful to the former.
> 
> Users can set this variable depending on their system. For example,
> Linux users can use `-s --strip-program=strip`, while FreeBSD users can
> simply set to `-s` and choose strip program with $STRIPBIN.
> 
> Helped-by: Junio C Hamano <[email-masked]>
> Signed-off-by: Bagas Sanjaya <[email-masked]>
> Signed-off-by: Junio C Hamano <[email-masked]>

So, here is my SoB, too:

Signed-off-by: Đoàn Trần Công Danh <[email-masked]>

-- Danh

> ---
>  Makefile | 15 ++++++++++++---
>  1 file changed, 12 insertions(+), 3 deletions(-)
> 
> diff --git a/Makefile b/Makefile
> index d1feab008f..ebef4da50c 100644
> --- a/Makefile
> +++ b/Makefile
> @@ -465,6 +465,9 @@ all::
>  # the global variable _wpgmptr containing the absolute path of the current
>  # executable (this is the case on Windows).
>  #
> +# INSTALL_STRIP can be set to "-s" to strip binaries during installation,
> +# if your $(INSTALL) command supports the option.
> +#
>  # Define GENERATE_COMPILATION_DATABASE to "yes" to generate JSON compilation
>  # database entries during compilation if your compiler supports it, using the
>  # `-MJ` flag. The JSON entries will be placed in the `compile_commands/`
> @@ -3004,7 +3007,8 @@ mergetools_instdir = $(prefix)/$(mergetoolsdir)
>  endif
>  mergetools_instdir_SQ = $(subst ','\'',$(mergetools_instdir))
>  
> -install_bindir_programs := $(patsubst %,%$X,$(BINDIR_PROGRAMS_NEED_X)) $(BINDIR_PROGRAMS_NO_X)
> +install_bindir_xprograms := $(patsubst %,%$X,$(BINDIR_PROGRAMS_NEED_X))
> +install_bindir_programs := $(install_bindir_xprograms) $(BINDIR_PROGRAMS_NO_X)
>  
>  .PHONY: profile-install profile-fast-install
>  profile-install: profile
> @@ -3013,12 +3017,17 @@ profile-install: profile
>  profile-fast-install: profile-fast
>  	$(MAKE) install
>  
> +INSTALL_STRIP =
> +
>  install: all
>  	$(INSTALL) -d -m 755 '$(DESTDIR_SQ)$(bindir_SQ)'
>  	$(INSTALL) -d -m 755 '$(DESTDIR_SQ)$(gitexec_instdir_SQ)'
> -	$(INSTALL) $(ALL_PROGRAMS) '$(DESTDIR_SQ)$(gitexec_instdir_SQ)'
> +	$(INSTALL) $(INSTALL_STRIP) $(PROGRAMS) '$(DESTDIR_SQ)$(gitexec_instdir_SQ)'
> +	$(INSTALL) $(SCRIPTS) '$(DESTDIR_SQ)$(gitexec_instdir_SQ)'
>  	$(INSTALL) -m 644 $(SCRIPT_LIB) '$(DESTDIR_SQ)$(gitexec_instdir_SQ)'
> -	$(INSTALL) $(install_bindir_programs) '$(DESTDIR_SQ)$(bindir_SQ)'
> +	$(INSTALL) $(INSTALL_STRIP) $(install_bindir_xprograms) '$(DESTDIR_SQ)$(bindir_SQ)'
> +	$(INSTALL) $(BINDIR_PROGRAMS_NO_X) '$(DESTDIR_SQ)$(bindir_SQ)'
> +
>  ifdef MSVC
>  	# We DO NOT install the individual foo.o.pdb files because they
>  	# have already been rolled up into the exe's pdb file.
> -- 
> 2.33.0-408-g8e1aa136b3
> 

-- 
Danh